#include "wavedec.h"
#include "test.h"
#include "events.h"
#include "wavelets.h"

WImage imageR = NULL, imageG = NULL, imageB = NULL;

float min_, max_, QMax[2][2], QMin[2][2], Widths[2][2], Areas[2][2];
int wImageSize;
GLubyte *WaveletBits = NULL;
int *Histogram[3] = {NULL, NULL, NULL};
int HistCoord[2] = {1, 1};
int more_info = 0;

void alloc_mem(){
	int size, i, j;
	if(imageR) free_ima(imageR, wImageSize); 
	if(imageG) free_ima(imageG, wImageSize);
	if(imageB) free_ima(imageB, wImageSize);
//	if(WaveletBits) free(WaveletBits); 
	wImageSize = (GRAB_WIDTH > GRAB_HEIGHT) ? GRAB_WIDTH : GRAB_HEIGHT;
	i = 0; j = wImageSize;
	while(j>>=1) i++; //    wImageSize  2 
	if(wImageSize != 1<<i) wImageSize = 1<<(i+1);
//	size = wImageSize * wImageSize;
	size = GRAB_WIDTH * GRAB_HEIGHT * 3;
	imageR = alloc_ima(wImageSize, wImageSize, 1);
	imageG = alloc_ima(wImageSize, wImageSize, 1);
	imageB = alloc_ima(wImageSize, wImageSize, 1);
	if(!WaveletBits) WaveletBits = (GLubyte *)calloc(3*size, sizeof(GLubyte));
//	WARN("init memory for wavelets, ext size=%d\n", wImageSize);	
}
/*
void emptyMem(){
	int i,j;
	for(i=0; i<wImageSize; i++)
		for(j=0; j<wImageSize; j++)
			imageR[j][i]=imageG[j][i]=imageB[j][i] = 0.;
}*/

void initWavelet(){ //  -    .
	int i, j, k, wd = GRAB_HEIGHT+1, stx = 1, sty = 1;
	float *ptr[3];
//	if(!(WaveletBits && imageR && imageG && imageB))
		alloc_mem();
//	emptyMem();
	GLubyte *bytes = BitmapBits;
	if(GRAB_WIDTH == wImageSize) stx = 0;
	if(GRAB_HEIGHT == wImageSize){ sty = 0; wd--; }
	for(j = sty; j < wd; j++){
		ptr[0] = &imageR[j][stx]; ptr[1] = &imageG[j][stx]; ptr[2] = &imageB[j][stx];
		for(i = 0; i < GRAB_WIDTH; i++){
			for(k = 0; k < 3; k++)
				*(ptr[k]++) = (float)(*bytes++);
		}
	}
	
	
	
/*	fprintf(stderr, "   . : %dx%d (.: %d)\n",
		GRAB_WIDTH, GRAB_HEIGHT, wImageSize);*/
}

void mkWavedec(){
	float *ptr[3], wdth;
	int j, i, k, shift_arr_r[MAX_ARR_SIZE],shift_arr_c[MAX_ARR_SIZE];
	const int levs=1;
	GLubyte *bytes;
	inline void findminmax(WImage image, char flag){
		float *ptr, pixval;
		int w2 = GRAB_WIDTH/2-2, h2 = GRAB_HEIGHT/2, s2 = wImageSize/2;
		int XLb = w2, XHb = s2+w2, YHb = s2+h2;
		int i, j, px, py;
		s2++;
		if(flag){
			min_ = 1e30; max_ = -1e30;
			for(i=0; i<2; i++) for(j=0; j<2; j++){
				QMax[i][j] = -1e30; QMin[i][j] = 1e30;
				Areas[i][j] = 0.;
			}
		}
		//image += YLb;
		for(j=0; j<YHb; j++, image++){
			if(j < h2) py = 0;
			else if(j > s2) py = 1;
			else continue;
			ptr = *image;
			for(i=0; i<XHb; i++, ptr++){
				if(i < XLb) px = 0;
				else if(i > s2) px = 1;
				else continue;
				pixval = *ptr;
				if(min_ > pixval) min_ = pixval;
				else if(max_ < pixval) max_ = pixval;
				if(QMin[py][px] > pixval) QMin[py][px] = pixval;
				else if(QMax[py][px] < pixval) QMax[py][px] = pixval;
				Areas[py][px] += fabs(pixval);
			}
		}
	}
	inline GLubyte testpix(int pix){
		int res = pix; if(res < 0) res = 0; else if(res > 255) res = 255;
		return (GLubyte)res;
	}
	initWavelet();
	for(i=levs-1; i>=0; i--)
		shift_arr_r[i]=shift_arr_c[i]=0;
	wav2d_inpl(imageR,wImageSize,wImageSize,levs,1,shift_arr_r,shift_arr_c);
	wav2d_inpl(imageG,wImageSize,wImageSize,levs,1,shift_arr_r,shift_arr_c);
	wav2d_inpl(imageB,wImageSize,wImageSize,levs,1,shift_arr_r,shift_arr_c);
	findminmax(imageR, 1);
	findminmax(imageG, 0);
	findminmax(imageB, 0);
	wdth = 255. / (max_ - min_);
	bytes = WaveletBits;

	{
	float scale;
	bool flagy, flagx;
	int sx = GRAB_WIDTH/2+1, sy = GRAB_HEIGHT/2+1, w2 = wImageSize/2-1,
		hx = w2 + sx, hy = w2 + sy, stx = 1, sty = 1;
	if(GRAB_WIDTH == wImageSize){ stx = 0; hx--;}
	if(GRAB_HEIGHT == wImageSize){ sty = 0; hy--;}
	for(j = sty; j < hy; j++){
		ptr[0] = &imageR[j][stx]; ptr[1] = &imageG[j][stx]; ptr[2] = &imageB[j][stx];
		flagy = (j < sy) || (j > w2);
		for(i = stx; i < hx; i++){
			flagx = (i < sx) || (i > w2);
			scale = 255./Widths[j>sy][i>sx];
			for(k = 0; k < 3; k++){
				if(flagx & flagy)
					*bytes++ = (GLubyte) ((*ptr[k] - QMin[j>sy][i>sx]) * scale);
				ptr[k]++;
			}
		}
	}
	}
	for(j=0; j<2; j++) for(i=0; i<2; i++)
		Widths[j][i] = QMax[j][i] - QMin[j][i];
	if(more_info){
		fprintf(stderr, "max=%.3g, min=%.3g\n", max_, min_);
		fprintf(stderr, "   (min, max):\n");
		fprintf(stderr, "(%.3g, %.3g)\t\t\t(%.3g, %.3g)\n", QMin[0][0], QMax[0][0],
			QMin[0][1], QMax[0][1]);
		fprintf(stderr, "(%.3g, %.3g)\t\t\t(%.3g, %.3g)\n", QMin[1][0], QMax[1][0],
			QMin[1][1], QMax[1][1]);
	}
}

void buildHistogram(){ //     -
	int x, y, k, x0, y0, dx;
	GLubyte *ptr;
	if(Histogram[0]){free(Histogram[0]);free(Histogram[1]);free(Histogram[2]);}
	for(x=0; x<3; x++)
		Histogram[x] = (int*) calloc(256, sizeof(float));
	x0 = HistCoord[0] * GRAB_WIDTH/2;
	y0 = HistCoord[0] * GRAB_HEIGHT/2;
	ptr = &WaveletBits[(y0*GRAB_WIDTH+x0)*3];
	x0 = GRAB_WIDTH/2;
	y0 = GRAB_HEIGHT/2;
	dx = x0 * 3;
	for(y=0; y<y0; y++){
		for(x=0; x<x0; x++)
			for(k=0; k<3; k++)
				Histogram[k][*ptr++]++;
		ptr += dx;
	}
}

